tests: fix false failure with spaces in absolute $PWD
[coreutils.git] / tests / init.sh
blobee0802241ff56f137e770c9a2b3e8339f0f0cdd1
1 # source this file; set up for tests
3 # Copyright (C) 2009-2016 Free Software Foundation, Inc.
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see <http://www.gnu.org/licenses/>.
18 # Using this file in a test
19 # =========================
21 # The typical skeleton of a test looks like this:
23 # #!/bin/sh
24 # . "${srcdir=.}/init.sh"; path_prepend_ .
25 # Execute some commands.
26 # Note that these commands are executed in a subdirectory, therefore you
27 # need to prepend "../" to relative filenames in the build directory.
28 # Note that the "path_prepend_ ." is useful only if the body of your
29 # test invokes programs residing in the initial directory.
30 # For example, if the programs you want to test are in src/, and this test
31 # script is named tests/test-1, then you would use "path_prepend_ ../src",
32 # or perhaps export PATH='$(abs_top_builddir)/src$(PATH_SEPARATOR)'"$$PATH"
33 # to all tests via automake's TESTS_ENVIRONMENT.
34 # Set the exit code 0 for success, 77 for skipped, or 1 or other for failure.
35 # Use the skip_ and fail_ functions to print a diagnostic and then exit
36 # with the corresponding exit code.
37 # Exit $?
39 # Executing a test that uses this file
40 # ====================================
42 # Running a single test:
43 # $ make check TESTS=test-foo.sh
45 # Running a single test, with verbose output:
46 # $ make check TESTS=test-foo.sh VERBOSE=yes
48 # Running a single test, with single-stepping:
49 # 1. Go into a sub-shell:
50 # $ bash
51 # 2. Set relevant environment variables from TESTS_ENVIRONMENT in the
52 # Makefile:
53 # $ export srcdir=../../tests # this is an example
54 # 3. Execute the commands from the test, copy&pasting them one by one:
55 # $ . "$srcdir/init.sh"; path_prepend_ .
56 # ...
57 # 4. Finally
58 # $ exit
60 ME_=`expr "./$0" : '.*/\(.*\)$'`
62 # We use a trap below for cleanup. This requires us to go through
63 # hoops to get the right exit status transported through the handler.
64 # So use 'Exit STATUS' instead of 'exit STATUS' inside of the tests.
65 # Turn off errexit here so that we don't trip the bug with OSF1/Tru64
66 # sh inside this function.
67 Exit () { set +e; (exit $1); exit $1; }
69 # Print warnings (e.g., about skipped and failed tests) to this file number.
70 # Override by defining to say, 9, in init.cfg, and putting say,
71 # export ...ENVVAR_SETTINGS...; $(SHELL) 9>&2
72 # in the definition of TESTS_ENVIRONMENT in your tests/Makefile.am file.
73 # This is useful when using automake's parallel tests mode, to print
74 # the reason for skip/failure to console, rather than to the .log files.
75 : ${stderr_fileno_=2}
77 # Note that correct expansion of "$*" depends on IFS starting with ' '.
78 # Always write the full diagnostic to stderr.
79 # When stderr_fileno_ is not 2, also emit the first line of the
80 # diagnostic to that file descriptor.
81 warn_ ()
83 # If IFS does not start with ' ', set it and emit the warning in a subshell.
84 case $IFS in
85 ' '*) printf '%s\n' "$*" >&2
86 test $stderr_fileno_ = 2 \
87 || { printf '%s\n' "$*" | sed 1q >&$stderr_fileno_ ; } ;;
88 *) (IFS=' '; warn_ "$@");;
89 esac
91 fail_ () { warn_ "$ME_: failed test: $@"; Exit 1; }
92 skip_ () { warn_ "$ME_: skipped test: $@"; Exit 77; }
93 fatal_ () { warn_ "$ME_: hard error: $@"; Exit 99; }
94 framework_failure_ () { warn_ "$ME_: set-up failure: $@"; Exit 99; }
96 # This is used to simplify checking of the return value
97 # which is useful when ensuring a command fails as desired.
98 # I.e., just doing `command ... &&fail=1` will not catch
99 # a segfault in command for example. With this helper you
100 # instead check an explicit exit code like
101 # returns_ 1 command ... || fail
102 returns_ () {
103 # Disable tracing so it doesn't interfere with stderr of the wrapped command
104 { set +x; } 2>/dev/null
106 local exp_exit="$1"
107 shift
108 "$@"
109 test $? -eq $exp_exit && ret_=0 || ret_=1
111 if test "$VERBOSE" = yes && test "$gl_set_x_corrupts_stderr_" = false; then
112 set -x
114 { return $ret_; } 2>/dev/null
117 # Sanitize this shell to POSIX mode, if possible.
118 DUALCASE=1; export DUALCASE
119 if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
120 emulate sh
121 NULLCMD=:
122 alias -g '${1+"$@"}'='"$@"'
123 setopt NO_GLOB_SUBST
124 else
125 case `(set -o) 2>/dev/null` in
126 *posix*) set -o posix ;;
127 esac
130 # We require $(...) support unconditionally.
131 # We require a few additional shell features only when $EXEEXT is nonempty,
132 # in order to support automatic $EXEEXT emulation:
133 # - hyphen-containing alias names
134 # - we prefer to use ${var#...} substitution, rather than having
135 # to work around lack of support for that feature.
136 # The following code attempts to find a shell with support for these features.
137 # If the current shell passes the test, we're done. Otherwise, test other
138 # shells until we find one that passes. If one is found, re-exec it.
139 # If no acceptable shell is found, skip the current test.
141 # The "...set -x; P=1 true 2>err..." test is to disqualify any shell that
142 # emits "P=1" into err, as /bin/sh from SunOS 5.11 and OpenBSD 4.7 do.
144 # Use "9" to indicate success (rather than 0), in case some shell acts
145 # like Solaris 10's /bin/sh but exits successfully instead of with status 2.
147 # Eval this code in a subshell to determine a shell's suitability.
148 # 10 - passes all tests; ok to use
149 # 9 - ok, but enabling "set -x" corrupts app stderr; prefer higher score
150 # ? - not ok
151 gl_shell_test_script_='
152 test $(echo y) = y || exit 1
153 f_local_() { local v=1; }; f_local_ || exit 1
154 score_=10
155 if test "$VERBOSE" = yes; then
156 test -n "$( (exec 3>&1; set -x; P=1 true 2>&3) 2> /dev/null)" && score_=9
158 test -z "$EXEEXT" && exit $score_
159 shopt -s expand_aliases
160 alias a-b="echo zoo"
161 v=abx
162 test ${v%x} = ab \
163 && test ${v#a} = bx \
164 && test $(a-b) = zoo \
165 && exit $score_
168 if test "x$1" = "x--no-reexec"; then
169 shift
170 else
171 # Assume a working shell. Export to subshells (setup_ needs this).
172 gl_set_x_corrupts_stderr_=false
173 export gl_set_x_corrupts_stderr_
175 # Record the first marginally acceptable shell.
176 marginal_=
178 # Search for a shell that meets our requirements.
179 for re_shell_ in __current__ "${CONFIG_SHELL:-no_shell}" \
180 /bin/sh bash dash zsh pdksh fail
182 test "$re_shell_" = no_shell && continue
184 # If we've made it all the way to the sentinel, "fail" without
185 # finding even a marginal shell, skip this test.
186 if test "$re_shell_" = fail; then
187 test -z "$marginal_" && skip_ failed to find an adequate shell
188 re_shell_=$marginal_
189 break
192 # When testing the current shell, simply "eval" the test code.
193 # Otherwise, run it via $re_shell_ -c ...
194 if test "$re_shell_" = __current__; then
195 # 'eval'ing this code makes Solaris 10's /bin/sh exit with
196 # $? set to 2. It does not evaluate any of the code after the
197 # "unexpected" first '('. Thus, we must run it in a subshell.
198 ( eval "$gl_shell_test_script_" ) > /dev/null 2>&1
199 else
200 "$re_shell_" -c "$gl_shell_test_script_" 2>/dev/null
203 st_=$?
205 # $re_shell_ works just fine. Use it.
206 if test $st_ = 10; then
207 gl_set_x_corrupts_stderr_=false
208 break
211 # If this is our first marginally acceptable shell, remember it.
212 if test "$st_:$marginal_" = 9: ; then
213 marginal_="$re_shell_"
214 gl_set_x_corrupts_stderr_=true
216 done
218 if test "$re_shell_" != __current__; then
219 # Found a usable shell. Preserve -v and -x.
220 case $- in
221 *v*x* | *x*v*) opts_=-vx ;;
222 *v*) opts_=-v ;;
223 *x*) opts_=-x ;;
224 *) opts_= ;;
225 esac
226 re_shell=$re_shell_
227 export re_shell
228 exec "$re_shell_" $opts_ "$0" --no-reexec "$@"
229 echo "$ME_: exec failed" 1>&2
230 exit 127
234 # If this is bash, turn off all aliases.
235 test -n "$BASH_VERSION" && unalias -a
237 # Note that when supporting $EXEEXT (transparently mapping from PROG_NAME to
238 # PROG_NAME.exe), we want to support hyphen-containing names like test-acos.
239 # That is part of the shell-selection test above. Why use aliases rather
240 # than functions? Because support for hyphen-containing aliases is more
241 # widespread than that for hyphen-containing function names.
242 test -n "$EXEEXT" && shopt -s expand_aliases
244 # Enable glibc's malloc-perturbing option.
245 # This is useful for exposing code that depends on the fact that
246 # malloc-related functions often return memory that is mostly zeroed.
247 # If you have the time and cycles, use valgrind to do an even better job.
248 : ${MALLOC_PERTURB_=87}
249 export MALLOC_PERTURB_
251 # This is a stub function that is run upon trap (upon regular exit and
252 # interrupt). Override it with a per-test function, e.g., to unmount
253 # a partition, or to undo any other global state changes.
254 cleanup_ () { :; }
256 # Emit a header similar to that from diff -u; Print the simulated "diff"
257 # command so that the order of arguments is clear. Don't bother with @@ lines.
258 emit_diff_u_header_ ()
260 printf '%s\n' "diff -u $*" \
261 "--- $1 1970-01-01" \
262 "+++ $2 1970-01-01"
265 # Arrange not to let diff or cmp operate on /dev/null,
266 # since on some systems (at least OSF/1 5.1), that doesn't work.
267 # When there are not two arguments, or no argument is /dev/null, return 2.
268 # When one argument is /dev/null and the other is not empty,
269 # cat the nonempty file to stderr and return 1.
270 # Otherwise, return 0.
271 compare_dev_null_ ()
273 test $# = 2 || return 2
275 if test "x$1" = x/dev/null; then
276 test -s "$2" || return 0
277 emit_diff_u_header_ "$@"; sed 's/^/+/' "$2"
278 return 1
281 if test "x$2" = x/dev/null; then
282 test -s "$1" || return 0
283 emit_diff_u_header_ "$@"; sed 's/^/-/' "$1"
284 return 1
287 return 2
290 if diff_out_=`exec 2>/dev/null; diff -u "$0" "$0" < /dev/null` \
291 && diff -u Makefile "$0" 2>/dev/null | grep '^[+]#!' >/dev/null; then
292 # diff accepts the -u option and does not (like AIX 7 'diff') produce an
293 # extra space on column 1 of every content line.
294 if test -z "$diff_out_"; then
295 compare_ () { diff -u "$@"; }
296 else
297 compare_ ()
299 if diff -u "$@" > diff.out; then
300 # No differences were found, but Solaris 'diff' produces output
301 # "No differences encountered". Hide this output.
302 rm -f diff.out
303 true
304 else
305 cat diff.out
306 rm -f diff.out
307 false
311 elif diff_out_=`exec 2>/dev/null; diff -c "$0" "$0" < /dev/null`; then
312 if test -z "$diff_out_"; then
313 compare_ () { diff -c "$@"; }
314 else
315 compare_ ()
317 if diff -c "$@" > diff.out; then
318 # No differences were found, but AIX and HP-UX 'diff' produce output
319 # "No differences encountered" or "There are no differences between the
320 # files.". Hide this output.
321 rm -f diff.out
322 true
323 else
324 cat diff.out
325 rm -f diff.out
326 false
330 elif cmp -s /dev/null /dev/null 2>/dev/null; then
331 compare_ () { cmp -s "$@"; }
332 else
333 compare_ () { cmp "$@"; }
336 # Usage: compare EXPECTED ACTUAL
338 # Given compare_dev_null_'s preprocessing, defer to compare_ if 2 or more.
339 # Otherwise, propagate $? to caller: any diffs have already been printed.
340 compare ()
342 # This looks like it can be factored to use a simple "case $?"
343 # after unchecked compare_dev_null_ invocation, but that would
344 # fail in a "set -e" environment.
345 if compare_dev_null_ "$@"; then
346 return 0
347 else
348 case $? in
349 1) return 1;;
350 *) compare_ "$@";;
351 esac
355 # An arbitrary prefix to help distinguish test directories.
356 testdir_prefix_ () { printf gt; }
358 # Run the user-overridable cleanup_ function, remove the temporary
359 # directory and exit with the incoming value of $?.
360 remove_tmp_ ()
362 __st=$?
363 cleanup_
364 # cd out of the directory we're about to remove
365 cd "$initial_cwd_" || cd / || cd /tmp
366 chmod -R u+rwx "$test_dir_"
367 # If removal fails and exit status was to be 0, then change it to 1.
368 rm -rf "$test_dir_" || { test $__st = 0 && __st=1; }
369 exit $__st
372 # Given a directory name, DIR, if every entry in it that matches *.exe
373 # contains only the specified bytes (see the case stmt below), then print
374 # a space-separated list of those names and return 0. Otherwise, don't
375 # print anything and return 1. Naming constraints apply also to DIR.
376 find_exe_basenames_ ()
378 feb_dir_=$1
379 feb_fail_=0
380 feb_result_=
381 feb_sp_=
382 for feb_file_ in $feb_dir_/*.exe; do
383 # If there was no *.exe file, or there existed a file named "*.exe" that
384 # was deleted between the above glob expansion and the existence test
385 # below, just skip it.
386 test "x$feb_file_" = "x$feb_dir_/*.exe" && test ! -f "$feb_file_" \
387 && continue
388 # Exempt [.exe, since we can't create a function by that name, yet
389 # we can't invoke [ by PATH search anyways due to shell builtins.
390 test "x$feb_file_" = "x$feb_dir_/[.exe" && continue
391 case $feb_file_ in
392 *[!-a-zA-Z/0-9_.+]*) feb_fail_=1; break;;
393 *) # Remove leading file name components as well as the .exe suffix.
394 feb_file_=${feb_file_##*/}
395 feb_file_=${feb_file_%.exe}
396 feb_result_="$feb_result_$feb_sp_$feb_file_";;
397 esac
398 feb_sp_=' '
399 done
400 test $feb_fail_ = 0 && printf %s "$feb_result_"
401 return $feb_fail_
404 # Consider the files in directory, $1.
405 # For each file name of the form PROG.exe, create an alias named
406 # PROG that simply invokes PROG.exe, then return 0. If any selected
407 # file name or the directory name, $1, contains an unexpected character,
408 # define no alias and return 1.
409 create_exe_shims_ ()
411 case $EXEEXT in
412 '') return 0 ;;
413 .exe) ;;
414 *) echo "$0: unexpected \$EXEEXT value: $EXEEXT" 1>&2; return 1 ;;
415 esac
417 base_names_=`find_exe_basenames_ $1` \
418 || { echo "$0 (exe_shim): skipping directory: $1" 1>&2; return 0; }
420 if test -n "$base_names_"; then
421 for base_ in $base_names_; do
422 alias "$base_"="$base_$EXEEXT"
423 done
426 return 0
429 # Use this function to prepend to PATH an absolute name for each
430 # specified, possibly-$initial_cwd_-relative, directory.
431 path_prepend_ ()
433 while test $# != 0; do
434 path_dir_=$1
435 case $path_dir_ in
436 '') fail_ "invalid path dir: '$1'";;
437 /*) abs_path_dir_=$path_dir_;;
438 *) abs_path_dir_=$initial_cwd_/$path_dir_;;
439 esac
440 case $abs_path_dir_ in
441 *:*) fail_ "invalid path dir: '$abs_path_dir_'";;
442 esac
443 PATH="$abs_path_dir_:$PATH"
445 # Create an alias, FOO, for each FOO.exe in this directory.
446 create_exe_shims_ "$abs_path_dir_" \
447 || fail_ "something failed (above): $abs_path_dir_"
448 shift
449 done
450 export PATH
453 setup_ ()
455 if test "$VERBOSE" = yes; then
456 # Test whether set -x may cause the selected shell to corrupt an
457 # application's stderr. Many do, including zsh-4.3.10 and the /bin/sh
458 # from SunOS 5.11, OpenBSD 4.7 and Irix 5.x and 6.5.
459 # If enabling verbose output this way would cause trouble, simply
460 # issue a warning and refrain.
461 if $gl_set_x_corrupts_stderr_; then
462 warn_ "using SHELL=$SHELL with 'set -x' corrupts stderr"
463 else
464 set -x
468 initial_cwd_=$PWD
469 fail=0
471 pfx_=`testdir_prefix_`
472 test_dir_=`mktempd_ "$initial_cwd_" "$pfx_-$ME_.XXXX"` \
473 || fail_ "failed to create temporary directory in $initial_cwd_"
474 cd "$test_dir_" || fail_ "failed to cd to temporary directory"
476 # As autoconf-generated configure scripts do, ensure that IFS
477 # is defined initially, so that saving and restoring $IFS works.
478 gl_init_sh_nl_='
480 IFS=" "" $gl_init_sh_nl_"
482 # This trap statement, along with a trap on 0 below, ensure that the
483 # temporary directory, $test_dir_, is removed upon exit as well as
484 # upon receipt of any of the listed signals.
485 for sig_ in 1 2 3 13 15; do
486 eval "trap 'Exit $(expr $sig_ + 128)' $sig_"
487 done
490 # Create a temporary directory, much like mktemp -d does.
491 # Written by Jim Meyering.
493 # Usage: mktempd_ /tmp phoey.XXXXXXXXXX
495 # First, try to use the mktemp program.
496 # Failing that, we'll roll our own mktemp-like function:
497 # - try to get random bytes from /dev/urandom
498 # - failing that, generate output from a combination of quickly-varying
499 # sources and gzip. Ignore non-varying gzip header, and extract
500 # "random" bits from there.
501 # - given those bits, map to file-name bytes using tr, and try to create
502 # the desired directory.
503 # - make only $MAX_TRIES_ attempts
505 # Helper function. Print $N pseudo-random bytes from a-zA-Z0-9.
506 rand_bytes_ ()
508 n_=$1
510 # Maybe try openssl rand -base64 $n_prime_|tr '+/=\012' abcd first?
511 # But if they have openssl, they probably have mktemp, too.
513 chars_=abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789
514 dev_rand_=/dev/urandom
515 if test -r "$dev_rand_"; then
516 # Note: 256-length($chars_) == 194; 3 copies of $chars_ is 186 + 8 = 194.
517 dd ibs=$n_ count=1 if=$dev_rand_ 2>/dev/null \
518 | LC_ALL=C tr -c $chars_ 01234567$chars_$chars_$chars_
519 return
522 n_plus_50_=`expr $n_ + 50`
523 cmds_='date; date +%N; free; who -a; w; ps auxww; ps ef; netstat -n'
524 data_=` (eval "$cmds_") 2>&1 | gzip `
526 # Ensure that $data_ has length at least 50+$n_
527 while :; do
528 len_=`echo "$data_"|wc -c`
529 test $n_plus_50_ -le $len_ && break;
530 data_=` (echo "$data_"; eval "$cmds_") 2>&1 | gzip `
531 done
533 echo "$data_" \
534 | dd bs=1 skip=50 count=$n_ 2>/dev/null \
535 | LC_ALL=C tr -c $chars_ 01234567$chars_$chars_$chars_
538 mktempd_ ()
540 case $# in
541 2);;
542 *) fail_ "Usage: mktempd_ DIR TEMPLATE";;
543 esac
545 destdir_=$1
546 template_=$2
548 MAX_TRIES_=4
550 # Disallow any trailing slash on specified destdir:
551 # it would subvert the post-mktemp "case"-based destdir test.
552 case $destdir_ in
553 /) ;;
554 */) fail_ "invalid destination dir: remove trailing slash(es)";;
555 esac
557 case $template_ in
558 *XXXX) ;;
559 *) fail_ \
560 "invalid template: $template_ (must have a suffix of at least 4 X's)";;
561 esac
563 # First, try to use mktemp.
564 d=`unset TMPDIR; { mktemp -d -t -p "$destdir_" "$template_"; } 2>/dev/null` \
565 || fail=1
567 # The resulting name must be in the specified directory.
568 case $d in "$destdir_"*);; *) fail=1;; esac
570 # It must have created the directory.
571 test -d "$d" || fail=1
573 # It must have 0700 permissions. Handle sticky "S" bits.
574 perms=`ls -dgo "$d" 2>/dev/null|tr S -` || fail=1
575 case $perms in drwx------*) ;; *) fail=1;; esac
577 test $fail = 0 && {
578 echo "$d"
579 return
582 # If we reach this point, we'll have to create a directory manually.
584 # Get a copy of the template without its suffix of X's.
585 base_template_=`echo "$template_"|sed 's/XX*$//'`
587 # Calculate how many X's we've just removed.
588 template_length_=`echo "$template_" | wc -c`
589 nx_=`echo "$base_template_" | wc -c`
590 nx_=`expr $template_length_ - $nx_`
592 err_=
593 i_=1
594 while :; do
595 X_=`rand_bytes_ $nx_`
596 candidate_dir_="$destdir_/$base_template_$X_"
597 err_=`mkdir -m 0700 "$candidate_dir_" 2>&1` \
598 && { echo "$candidate_dir_"; return; }
599 test $MAX_TRIES_ -le $i_ && break;
600 i_=`expr $i_ + 1`
601 done
602 fail_ "$err_"
605 # If you want to override the testdir_prefix_ function,
606 # or to add more utility functions, use this file.
607 test -f "$srcdir/init.cfg" \
608 && . "$srcdir/init.cfg"
610 setup_ "$@"
611 # This trap is here, rather than in the setup_ function, because some
612 # shells run the exit trap at shell function exit, rather than script exit.
613 trap remove_tmp_ 0